/*---------------------------------------
   ANSIOEM.C -- Ansi & Oem Characters.
                 (c) Robert Digsby, 1992
  ---------------------------------------*/

#include <windows.h>

#define DIVISIONSX 32
#define DIVISIONSY  8
#define ANSI        0
#define OEM         1
#define STATUS      2
 
long FAR PASCAL WndProc        (HWND, WORD, WORD, LONG) ;
long FAR PASCAL AnsiOemWndProc (HWND, WORD, WORD, LONG) ;
long FAR PASCAL StatusWndProc  (HWND, WORD, WORD, LONG) ;

HWND  hwndChild [3] ;
char  szAnsiOemClass[] = "AnsiOem_Child" ;
char  szStatusClass[]  = "Status_Child" ;
short cxBlock, cyBlock, cxChar, cyChar ;

int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR  lpszCmdLine, int nCmdShow)
     {
     static char szAppName[] = "AnsiOem" ;
     HWND        hwnd ;
     MSG         msg ;
     WNDCLASS    wndclass ;

     if (!hPrevInstance) 
          {
          wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
	  wndclass.lpfnWndProc   = WndProc ;
          wndclass.cbClsExtra    = 0 ;
          wndclass.cbWndExtra    = 0 ;
          wndclass.hInstance     = hInstance ;
          wndclass.hIcon         = NULL ;
          wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
          wndclass.hbrBackground = COLOR_WINDOW + 1 ;
          wndclass.lpszMenuName  = NULL ;
          wndclass.lpszClassName = szAppName ;

          RegisterClass (&wndclass) ;

	  wndclass.lpfnWndProc   = AnsiOemWndProc ;
	  wndclass.cbWndExtra    = sizeof (DWORD) ;
          wndclass.hIcon         = NULL ;
	  wndclass.lpszClassName = szAnsiOemClass ;

	  RegisterClass (&wndclass) ;

	  wndclass.lpfnWndProc   = StatusWndProc ;
	  wndclass.cbWndExtra    = 0 ;
          wndclass.hIcon         = NULL ;
	  wndclass.lpszClassName = szStatusClass ;

	  RegisterClass (&wndclass) ;
	  }
	         
     hwnd = CreateWindow (szAppName, "Ansi & Oem Charaters",
                         WS_OVERLAPPEDWINDOW,
                         CW_USEDEFAULT, CW_USEDEFAULT,
                         CW_USEDEFAULT, CW_USEDEFAULT,
                         NULL, NULL, hInstance, NULL) ;

     ShowWindow (hwnd, nCmdShow) ;
     UpdateWindow (hwnd) ;

     while (GetMessage (&msg, NULL, 0, 0))
          {
          TranslateMessage (&msg) ;
          DispatchMessage (&msg) ;
          }
     return msg.wParam ;
     }

long FAR PASCAL WndProc (HWND hwnd, WORD message, WORD wParam, LONG lParam)
     {
     HDC          hdc ;
     TEXTMETRIC   tm ;
     short        cxClient, cyClient, cxAnsiPos, cyAnsiPos, cxScreen,
		  cyScreen, cxSize, cySize ;

     switch (message)
          {
	  case WM_CREATE :
	       hdc = GetDC (hwnd) ;

               SelectObject (hdc, GetStockObject (SYSTEM_FIXED_FONT)) ;

               GetTextMetrics (hdc, &tm) ;
               cxChar = tm.tmAveCharWidth ;
               cyChar = tm.tmHeight + tm.tmExternalLeading ;
               cxBlock = cxChar * 2 ;
               cyBlock = cyChar * 1.3; 

               ReleaseDC (hwnd, hdc) ;

	       cxScreen = GetSystemMetrics (SM_CXSCREEN) ;
	       cyScreen = GetSystemMetrics (SM_CYSCREEN) ;
	       cxSize = cxBlock * (DIVISIONSX + 2) ;
	       cySize = cyBlock * ((DIVISIONSY * 2) + 5) ;

	       MoveWindow (hwnd, (cxScreen - cxSize) / 2,
	            (cyScreen - cySize) / 2,
		    cxSize, cySize, FALSE) ;
               	       
	       hwndChild[ANSI] = CreateWindow (szAnsiOemClass, NULL,
		    WS_CHILDWINDOW | WS_VISIBLE,
		    0, 0, 0, 0,
		    hwnd, ANSI,
		    GetWindowWord (hwnd, GWW_HINSTANCE), NULL) ;

	       hwndChild[OEM] = CreateWindow (szAnsiOemClass, NULL,
		    WS_CHILDWINDOW | WS_VISIBLE,
		    0, 0, 0, 0,
                    hwnd, OEM,
		    GetWindowWord (hwnd, GWW_HINSTANCE), NULL) ;

	       hwndChild[STATUS] = CreateWindow (szStatusClass, NULL,
		    WS_CHILDWINDOW | WS_VISIBLE,
		    0, 0, 0, 0,
		    hwnd, STATUS,
		    GetWindowWord (hwnd, GWW_HINSTANCE), NULL) ;

               return 0 ;

	  case WM_SIZE :
	       cxClient = LOWORD (lParam) ;
	       cyClient = HIWORD (lParam) ;

	       cxAnsiPos = max (cxBlock,
	            (cxClient - (cxBlock * DIVISIONSX)) / 2) ;
	       cyAnsiPos = max (cyBlock,
	            ((cyClient - (cyBlock * ((DIVISIONSY * 2) + 2))) / 2)) ;
               
	       MoveWindow (hwndChild[ANSI], cxAnsiPos, cyAnsiPos,
		   cxBlock * DIVISIONSX, cyBlock * DIVISIONSY, TRUE) ;

	       MoveWindow (hwndChild[OEM],
		   cxAnsiPos,
		   cyAnsiPos + (cyBlock * DIVISIONSY) + (cyBlock * 2), 
		   cxBlock * DIVISIONSX, cyBlock * DIVISIONSY, TRUE) ;

	       MoveWindow (hwndChild[STATUS],
		   cxAnsiPos,
		   cyAnsiPos + (cyBlock * DIVISIONSY) + (cyBlock / 2),
		   cxBlock * DIVISIONSX, cyBlock, TRUE) ;

	       return 0 ;

          case WM_LBUTTONDOWN :
	       MessageBeep (0) ;
               return 0 ;
          	   
	  case WM_SETFOCUS :
               SetFocus (hwndChild[ANSI]) ;
               return 0 ;

          case WM_DESTROY :
	       PostQuitMessage (0) ;
               return 0 ;

	  }
     return DefWindowProc (hwnd, message, wParam, lParam) ;
     }


long FAR PASCAL AnsiOemWndProc (HWND hwnd, WORD message, WORD wParam, LONG lParam)
     {
     short         x, y, cxPos, cyPos, cPos, xStart, xEnd, yStart, yEnd, n ;
     unsigned char sBuffer[1], sConvert[1], sConverted[1] ;
     HDC           hdc ;
     PAINTSTRUCT   ps ;
     RECT          rect ;
     HBRUSH        hBrush ;
     DWORD         dwPrevColor, dwPrevText ;

     switch (message)
          {
	  case WM_CREATE:
	       SetWindowWord (hwnd, 0, 0) ;
	       SetWindowWord (hwnd, 2, 0) ;
	       return 0 ;

          case WM_PAINT:
	       hdc = BeginPaint (hwnd, &ps) ;
	       	        
               if (ANSI == GetWindowWord (hwnd, GWW_ID) )
		    SelectObject (hdc, GetStockObject (SYSTEM_FIXED_FONT)) ;
	       else
		    SelectObject (hdc, GetStockObject (OEM_FIXED_FONT)) ;
               	       			 
	       Rectangle (hdc, 0, 0, cxBlock * DIVISIONSX,
	            cyBlock * DIVISIONSY) ;

               xStart = ps.rcPaint.left / cxBlock ;
	       xEnd   = ps.rcPaint.right / cxBlock ;
	       yStart = ps.rcPaint.top / cyBlock ;
	       yEnd   = ps.rcPaint.bottom / cyBlock ;

	       for (x = xStart; x <= xEnd; x++)
		    {
		    MoveTo (hdc, x * cxBlock, 0) ;
		    LineTo (hdc, x * cxBlock, cyBlock * DIVISIONSY) ;
		    }

	       for (y = yStart; y <= yEnd; y++)
		    {
		    MoveTo (hdc, 0, y * cyBlock) ;
		    LineTo (hdc, cxBlock * DIVISIONSX, y * cyBlock) ;
		    }

               SetTextAlign (hdc, TA_CENTER) ;
	       SetTextColor(hdc, GetSysColor (COLOR_WINDOWTEXT)) ;
	       SetBkColor  (hdc, GetSysColor (COLOR_WINDOW)) ;


               for (y = yStart; y <= yEnd; y++)
	            for (x = xStart; x <= xEnd; x++)
                         {
		         if (y == GetWindowWord (hwnd, 2) &&
		              x == GetWindowWord (hwnd, 0))
			      {
			      SetRect (&rect, x * cxBlock, y * cyBlock,
	       	                   (x * cxBlock) + cxBlock,
                                   (y * cyBlock) + cyBlock) ;
			      if (hwnd == GetFocus())
                                   {
				   hBrush = CreateSolidBrush
				        (GetSysColor (COLOR_HIGHLIGHT) ) ;
				   SetTextColor(hdc,
				         GetSysColor (COLOR_HIGHLIGHTTEXT)) ;
				   SetBkColor (hdc,
                                         GetSysColor (COLOR_HIGHLIGHT)) ;
                                   }
		              else
                                   {
				   hBrush = CreateSolidBrush
				        (GetSysColor (COLOR_BTNFACE)) ;
				   SetBkColor (hdc,
					GetSysColor (COLOR_BTNFACE)) ;
                                   }
			      FillRect (hdc, &rect, hBrush) ;
                              DeleteObject (hBrush) ;
			      }
		         sBuffer[0] = (y * DIVISIONSX) + x ;
                         TextOut (hdc, (x * cxBlock) + cxChar,
		              (y * cyBlock) + (cyBlock - cyChar) / 2, 
			      sBuffer, 1) ;
		         if (y == GetWindowWord (hwnd, 2) &&
		              x == GetWindowWord (hwnd, 0))
                              {
			      SetTextColor(hdc, GetSysColor
			           (COLOR_WINDOWTEXT)) ;
			      SetBkColor  (hdc, GetSysColor
			           (COLOR_WINDOW)) ;
                              }
                         }                              	    	      

	       EndPaint (hwnd, &ps) ;

	       return 0 ;

	  case WM_CHAR :
	       n = GetWindowWord (hwnd, GWW_ID) ;

               if (wParam == VK_TAB)
		    {
                    n = !n ;
                    cPos = 0 ;
		    }
               else
                    cPos = wParam ;

	       cyPos = cPos / DIVISIONSX ;
	       cxPos = cPos % DIVISIONSX ;
	          					       
	       SendMessage (hwndChild[n], WM_LBUTTONDOWN, MK_LBUTTON,
                    MAKELONG (cxPos * cxBlock, cyPos * cyBlock)) ;
		
               return 0 ;


	  case WM_KEYDOWN :
	       n = GetWindowWord (hwnd, GWW_ID) ;

	       cxPos = GetWindowWord (hwnd, 0) ;
	       cyPos = GetWindowWord (hwnd, 2) ;
	       cPos  = (cyPos * DIVISIONSX) + cxPos ;

	       switch (wParam)
	            {
		    case VK_LEFT :
                         cPos-- ; 
			 break ;

		    case VK_RIGHT :
			 cPos++ ;
			 break ;

		    case VK_UP :
			 if (cPos - DIVISIONSX >= 0)
			      cPos -= DIVISIONSX ;
                         break ;

		    case VK_DOWN :
			 if (cPos + DIVISIONSX < DIVISIONSX * DIVISIONSY)
			      cPos += DIVISIONSX ;
                         break ;
                    }
	       
	       cPos = max (0, min (cPos, (DIVISIONSX * DIVISIONSY) - 1)) ;

               cyPos = cPos / DIVISIONSX ;
	       cxPos = cPos % DIVISIONSX ;
	          					       
               SendMessage (hwndChild[n], WM_LBUTTONDOWN, MK_LBUTTON,
                    MAKELONG (cxPos * cxBlock, cyPos * cyBlock)) ;
	       
               return 0 ;

	  case WM_LBUTTONDOWN :
               SetFocus (hwnd) ;

               for (n = 0; n <= OEM; n++)
		    {
	            cxPos = GetWindowWord (hwndChild[n], 0) ;
		    cyPos = GetWindowWord (hwndChild[n], 2) ;
	            SetRect (&rect, cxPos * cxBlock, cyPos * cyBlock,
		         (cxPos * cxBlock) + cxBlock,
		         (cyPos * cyBlock) + cyBlock) ;
                    InvalidateRect (hwndChild[n], &rect, TRUE) ;
                    }

	       cxPos = LOWORD (lParam) / cxBlock ;
	       cyPos = HIWORD (lParam) / cyBlock ;
	       SetWindowWord (hwnd, 0, cxPos) ;
	       SetWindowWord (hwnd, 2, cyPos) ;
	       SetRect (&rect, cxPos * cxBlock, cyPos * cyBlock,
	            (cxPos * cxBlock) + cxBlock,
	            (cyPos * cyBlock) + cyBlock) ;
               InvalidateRect (hwnd, &rect, TRUE) ;
	       
	       sConvert[0] = (cyPos * DIVISIONSX) + cxPos ;

	       if (ANSI == GetWindowWord (hwnd, GWW_ID))
                    {
                    n = OEM ;
                    AnsiToOemBuff (sConvert, sConverted, 1) ;
                    }
	       else
	            {
                    n = ANSI ;
	            OemToAnsiBuff (sConvert, sConverted, 1) ;
                    }

               cxPos = sConverted[0]  % DIVISIONSX ;
               cyPos = sConverted[0]  / DIVISIONSX ;

               SetWindowWord (hwndChild[n], 0, cxPos) ;
               SetWindowWord (hwndChild[n], 2, cyPos) ;
	       SetRect (&rect, cxPos * cxBlock, cyPos * cyBlock,
	       	    (cxPos * cxBlock) + cxBlock,
		    (cyPos * cyBlock) + cyBlock) ;
               InvalidateRect (hwndChild[n], &rect, TRUE) ;

	       InvalidateRect (hwndChild[STATUS], NULL, TRUE) ;

               return 0 ;
          }
     return DefWindowProc (hwnd, message, wParam, lParam) ;
     }


long FAR PASCAL StatusWndProc (HWND hwnd, WORD message, WORD wParam, LONG lParam)
     {
     HDC          hdc ;
     HBRUSH       hBrush ;
     PAINTSTRUCT  ps ;
     RECT         rect ;
     char         szBuffer[30], szFrom[5], szTo[5] ;
     short        nFrom, nTo, cxBox, cxPos, cyPos, nAnsi, nOem ;

     switch (message)
          {
	  case WM_PAINT :
	       hdc = BeginPaint (hwnd, &ps) ;

	       cxBox = (cxBlock * DIVISIONSX) / 3 ;

	       hBrush = CreateSolidBrush (GetSysColor (COLOR_HIGHLIGHT)) ;

	       SetRect (&rect, 0, 0, cxBox - cxBlock, cyBlock) ;
	       Rectangle (hdc, rect.left, rect.right,
	            rect.top, rect.bottom) ;
	       FillRect (hdc, &rect, hBrush) ;

	       SetRect (&rect, cxBox, 0, (cxBox * 2) - cxBlock, cyBlock) ;
	       Rectangle (hdc, rect.left, rect.right,
	            rect.top, rect.bottom) ;
	       FillRect (hdc, &rect, hBrush) ;
               	       
	       DeleteObject (hBrush) ;

	       hBrush = CreateSolidBrush (GetSysColor (COLOR_BTNFACE)) ;

	       SetRect (&rect, cxBox * 2, 0, cxBox * 3, cyBlock) ;
	       Rectangle (hdc, rect.left, rect.right,
	            rect.top, rect.bottom) ;
	       FillRect (hdc, &rect, hBrush) ;
               	       
	       DeleteObject (hBrush) ;
                      

	       cxPos = GetWindowWord (hwndChild[ANSI], 0) ;
	       cyPos = GetWindowWord (hwndChild[ANSI], 2) ;
               nAnsi = (cyPos * DIVISIONSX) + cxPos ; 

	       cxPos = GetWindowWord (hwndChild[OEM], 0) ;
	       cyPos = GetWindowWord (hwndChild[OEM], 2) ;
	       nOem  = (cyPos * DIVISIONSX) + cxPos ;

               if (hwndChild[ANSI] == GetFocus())
                    {
		    lstrcpy (szFrom, "ANSI") ;
		    lstrcpy (szTo, "OEM") ;
                    nFrom = nAnsi ;
                    nTo = nOem ;  
		    }
	       else
		    {
		    lstrcpy (szFrom, "OEM") ;
		    lstrcpy (szTo, "ANSI") ;
		    nFrom = nOem ;
                    nTo = nAnsi ; 
		    }

	       wsprintf (szBuffer,"%s to %s ",(LPSTR) szFrom, (LPSTR) szTo) ;

	       SetTextColor(hdc, GetSysColor (COLOR_HIGHLIGHTTEXT)) ;
	       SetBkColor  (hdc, GetSysColor (COLOR_HIGHLIGHT)) ;

               TextOut (hdc, cxBlock, (cyBlock - cyChar) / 2,
	            szBuffer, lstrlen(szBuffer)) ;

	       wsprintf (szBuffer, "%s Ascii: %d  %XH",
		    (LPSTR) szFrom, nFrom, nFrom) ;

	       TextOut (hdc, cxBox + cxBlock, (cyBlock - cyChar) / 2,
		    szBuffer, lstrlen(szBuffer)) ;

	       wsprintf (szBuffer, "%s Ascii: %d  %XH",
		    (LPSTR) szTo, nTo, nTo) ;

	       SetTextColor(hdc, GetSysColor (COLOR_WINDOWTEXT)) ;
	       SetBkColor  (hdc, GetSysColor (COLOR_BTNFACE)) ;

	       TextOut (hdc, (cxBox * 2) + cxBlock, (cyBlock - cyChar) / 2,
			 szBuffer, lstrlen(szBuffer)) ;

	       EndPaint (hwnd, &ps) ;     

	       return 0 ;

          case WM_LBUTTONDOWN:
	       MessageBeep (0) ;
	       return 0 ;
	  }

     return DefWindowProc (hwnd, message, wParam, lParam) ;
     }
